#include "mainwindow.h"

#define HELP_FILE "collection_doc.qhc"

MainWindow::MainWindow(QWidget *parent)
 : QMainWindow(parent)
{
	//	create menu.
	QMenu * pfileMenu = menuBar()->addMenu(tr("&File"));
	//	create status bar.
	QStatusBar *pstatus= statusBar();
	pstatus->showMessage(tr("Ready"));
	
	//	create action.
	m_help_act = pfileMenu->addAction("H&elp" );
	m_help_act->setShortcut(QKeySequence(QKeySequence::HelpContents));
	m_help_act->setStatusTip(tr("Show help"));
	
	m_help_change_act = pfileMenu->addAction("Change Page Help" );
	m_help_change_act->setStatusTip(tr("Change Page Help"));
	m_help_change_act->setEnabled(false);

	m_exit_act = pfileMenu->addAction(tr("E&xit" ));
	m_exit_act->setShortcut(tr("Ctrl+Q"));
	m_exit_act->setStatusTip(tr("Exit the application"));

	//	create help process.
	m_process_help = new QProcess(this);
	m_help_exec=false;
	
	//	action connect.
	connect(m_help_act, SIGNAL(triggered()), 
	         this, SLOT(OnHelp()));
	connect(m_help_change_act, SIGNAL(triggered()), 
	         this, SLOT(OnHelpChange()));
	connect(m_exit_act, SIGNAL(triggered()), 
	         qApp, SLOT(closeAllWindows()));


	connect(m_process_help,SIGNAL(started()),
			this,SLOT(OnStartedHelp()));
	connect(m_process_help,SIGNAL(finished(int , QProcess::ExitStatus )),
			this,SLOT(OnEndHelp(int , QProcess::ExitStatus )));


    setWindowTitle(tr("SampleWindow"));
	resize(400, 300);
}

void MainWindow::OnHelp()
{
	 QStringList args;
	 args <<   QLatin1String("-collectionFile")
	      << ( qApp->applicationDirPath() + "/" + HELP_FILE )
	      <<   QLatin1String("-enableRemoteControl");
	 m_process_help->start(QLatin1String("assistant"), args);
}
void MainWindow::OnHelpChange()
{
	QByteArray ba;
	ba.append("setSource qthelp://Sample_Help/doc/doc2.html");
	ba.append('\0');
	m_process_help->write(ba);
}
void MainWindow::OnStartedHelp()
{
	m_help_exec=true;
	statusBar()->showMessage(tr("Started HELP(Assistant)."));
	m_help_act->setEnabled(!m_help_exec);
	m_help_change_act->setEnabled(m_help_exec);
}
void MainWindow::OnEndHelp(int , QProcess::ExitStatus )
{
	m_help_exec=false;
	statusBar()->showMessage(tr("Closed HELP(Assistant)."));
	m_help_act->setEnabled(!m_help_exec);
	m_help_change_act->setEnabled(m_help_exec);
}
