#include "mainwindow.h"

MainWindow::MainWindow(QWidget *parent)
 : QMainWindow(parent)
{
	//	create menu.
	QMenu * pfileMenu = menuBar()->addMenu(tr("&File"));
	//	create status bar.
	QStatusBar *pstatus= statusBar();
	pstatus->showMessage(tr("Ready"));
	
	//	create action
	m_exit_act = pfileMenu->addAction(tr("E&xit" ));
	m_exit_act->setShortcut(tr("Ctrl+Q"));
	m_exit_act->setStatusTip(tr("Exit the application"));

	QSplitter *helpPanel = new QSplitter(Qt::Horizontal,this);
 
	//	help engine.
	m_helpEngine=new QHelpEngine(qApp->applicationDirPath()+"/collection_doc.qhc",this);
	m_helpEngine->setupData();
	m_phtml=new HelpBrowser (m_helpEngine,this);

	helpPanel->insertWidget(0, m_helpEngine->contentWidget());
    helpPanel->insertWidget(1, m_phtml);
	setCentralWidget(helpPanel);

	//	action connect.
	connect(m_exit_act, SIGNAL(triggered()), 
	         qApp, SLOT(closeAllWindows()));

	connect(m_helpEngine->contentWidget(),
	        SIGNAL(linkActivated(const QUrl &)),
	        m_phtml, SLOT(setSource(const QUrl &)));

    setWindowTitle(tr("SampleWindow"));
	resize(400, 300);
}
